//+------------------------------------------------------------------+
//|                                4BARS-MTF-BBH with arrow 1.05.mq4 |
//|                                            modified by gspe 2010 |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, "
#property link      "http://www./"

//---- indicator settings
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 5
#property indicator_buffers 8
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 LimeGreen
#property indicator_color4 Red
#property indicator_color5 LimeGreen
#property indicator_color6 Red
#property indicator_color7 LimeGreen
#property indicator_color8 Red

//---- parameters
extern int		BullsBearsPeriod  = 13;
extern int		BarWidth = 0;
extern color	BarColorUp = LimeGreen;
extern color	BarColorDown = Red;
extern color	TextColor = Black;
extern bool		ShowArrows = true;
//extern int ArrowGap = 200;
extern color	UpArrowColor = LimeGreen;
extern color	DownArrowColor = Red;
extern string	Note1 = "Use 2, 3 or 4 dots for arrows";
extern int		DotsforArrow = 3;
extern bool		AlertOnBarClose = true;
extern bool		SendAlert = true;
extern bool		SendEmail = false;
string			AlertMessageUp = "Buy";
string			AlertMessageDn = "Sell";

double Gap = 1; // Gap between the lines of bars
//---- buffers
double buf1_up[];
double buf1_dn[];
double buf2_up[];
double buf2_dn[];
double buf3_up[];
double buf3_dn[];
double buf4_up[];
double buf4_dn[];

string shortname = "";


int ArrSize = 112;//159;
int UniqueNum = 2282,t0;
int Signal;
bool AlertDone = false;
int Period_1, Period_2, Period_3, Period_4, ArrowGap;
string PerName_1, PerName_2, PerName_3, PerName_4;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
  

//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(0,ArrSize);
   SetIndexBuffer(0,buf1_up);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(1,ArrSize);
   SetIndexBuffer(1,buf1_dn);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(2,ArrSize);
   SetIndexBuffer(2,buf2_up);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(3,ArrSize);
   SetIndexBuffer(3,buf2_dn);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(4,ArrSize);
   SetIndexBuffer(4,buf3_up);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(5,ArrSize);
   SetIndexBuffer(5,buf3_dn);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(6,ArrSize);
   SetIndexBuffer(6,buf4_up);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(7,ArrSize);
   SetIndexBuffer(7,buf4_dn);
   SetIndexEmptyValue(7,0.0);
   
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   SetIndexLabel(7,NULL);
   
   IndicatorDigits(0);
   getPeriod();
   
   //shortname = "BBH-MTF-4 ("+Period_1+","+Period_2+","+Period_3+","+Period_4+")";
   shortname = "BBH-MTF-4 ("+PerName_1+","+PerName_2+","+PerName_3+","+PerName_4+")";
   IndicatorShortName(shortname);
   
   
//----
	return(0);
}
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	DeleteArrows();

	return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

void getPeriod()
{
   switch(Period()) 
      {
         case 1: 
            Period_1=1; Period_2=5; Period_3=15; Period_4=30;
            PerName_1="M1";PerName_2="M5";PerName_3="M15";PerName_4="M30";
            break;
         case 5: 
            Period_1=5; Period_2=15; Period_3=30; Period_4=60;
            PerName_1="M5";PerName_2="M15";PerName_3="M30";PerName_4="H1";
            break;
         case 15: 
            Period_1=15; Period_2=30; Period_3=60; Period_4=240;
            PerName_1="M15";PerName_2="M30";PerName_3="H1";PerName_4="H4";
            break;
         case 30: 
            Period_1=30; Period_2=60; Period_3=240; Period_4=1440;
            PerName_1="M30";PerName_2="H1";PerName_3="H4";PerName_4="D1";
            break;
         case 60: 
            Period_1=60; Period_2=240; Period_3=1440; Period_4=10080;
            PerName_1="H1";PerName_2="H4";PerName_3="D1";PerName_4="W1";
            break;
         case 240: 
            Period_1=240; Period_2=1440; Period_3=10080; Period_4=43200;
            PerName_1="H4";PerName_2="D1";PerName_3="W1";PerName_4="MN";
            break;
         case 1440: 
            Period_1=1440; Period_2=10080; Period_3=43200; Period_4=43200;
            PerName_1="D1";PerName_2="W1";PerName_3="MN";PerName_4="MN";
            break;
         case 10080: 
            Period_1=10080; Period_2=43200; Period_3=43200; Period_4=43200;
            PerName_1="W1";PerName_2="MN";PerName_3="MN";PerName_4="MN";
            break;
         case 43200: 
            Period_1=43200; Period_2=43200; Period_3=43200; Period_4=43200;
            PerName_1="MN";PerName_2="MN";PerName_3="MN";PerName_4="MN";
            break;
         
      }
}



int start()
  {
  
  
  if(DotsforArrow ==2 || DotsforArrow ==3 || DotsforArrow == 4)
  {
  
 // int ArrowGap = MathCeil(iATR(NULL,0,50,0)/Point);
     
   int counted_bars=IndicatorCounted();
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   //---- the last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   int i;
   int Period_1_shift=0,Period_2_shift=0,Period_3_shift=0,Period_4_shift=0;
   double BullPeriod_1, BearPeriod_1,BullPeriod_2, BearPeriod_2,BullPeriod_3, BearPeriod_3,BullPeriod_4, BearPeriod_4;

   
   
   
   //-------------------------------2----------------------------------------
	int  i1=0, i2=0, i3=0, i4=0, yy;

	for(i=limit; i>=0; i--)
	{
		Period_1_shift = iBarShift(NULL,Period_1,Time[i]);
		Period_2_shift = iBarShift(NULL,Period_2,Time[i]);
		Period_3_shift = iBarShift(NULL,Period_3,Time[i]);
		Period_4_shift = iBarShift(NULL,Period_4,Time[i]);
		
		BullPeriod_1 = (iBullsPower(NULL, Period_1, BullsBearsPeriod,PRICE_CLOSE,Period_1_shift));
		BearPeriod_1 = (iBearsPower(NULL, Period_1, BullsBearsPeriod,PRICE_CLOSE,Period_1_shift));
		BullPeriod_2 = (iBullsPower(NULL, Period_2, BullsBearsPeriod,PRICE_CLOSE,Period_2_shift));
		BearPeriod_2 = (iBearsPower(NULL, Period_2, BullsBearsPeriod,PRICE_CLOSE,Period_2_shift));
		BullPeriod_3 = (iBullsPower(NULL, Period_3, BullsBearsPeriod,PRICE_CLOSE,Period_3_shift));
		BearPeriod_3 = (iBearsPower(NULL, Period_3, BullsBearsPeriod,PRICE_CLOSE,Period_3_shift));
		BullPeriod_4 = (iBullsPower(NULL, Period_4, BullsBearsPeriod,PRICE_CLOSE,Period_4_shift));
		BearPeriod_4 = (iBearsPower(NULL, Period_4, BullsBearsPeriod,PRICE_CLOSE,Period_4_shift));
		
		if		( MathAbs(BullPeriod_1) > MathAbs(BearPeriod_1))	{buf1_up[i] = 1; buf1_dn[i] = EMPTY_VALUE;}
		else if	( MathAbs(BullPeriod_1) < MathAbs(BearPeriod_1))	{buf1_dn[i] = 1; buf1_up[i] = EMPTY_VALUE;}
		
		if		( MathAbs(BullPeriod_2) > MathAbs(BearPeriod_2))	{buf2_up[i] = 1 + Gap * 1; buf2_dn[i] = EMPTY_VALUE;}
		else if	( MathAbs(BullPeriod_2) < MathAbs(BearPeriod_2))	{buf2_dn[i] = 1 + Gap * 1; buf2_up[i] = EMPTY_VALUE;}
		
		if		( MathAbs(BullPeriod_3) > MathAbs(BearPeriod_3))	{buf3_up[i] = 1 + Gap * 2; buf3_dn[i] = EMPTY_VALUE;}
		else if	( MathAbs(BullPeriod_3) < MathAbs(BearPeriod_3))	{buf3_dn[i] = 1 + Gap * 2; buf3_up[i] = EMPTY_VALUE;}
		
		if		( MathAbs(BullPeriod_4) > MathAbs(BearPeriod_4))	{buf4_up[i] = 1 + Gap * 3; buf4_dn[i] = EMPTY_VALUE;}
		else if	( MathAbs(BullPeriod_4) < MathAbs(BearPeriod_4))	{buf4_dn[i] = 1 + Gap * 3; buf4_up[i] = EMPTY_VALUE;}
              
	}
   
	DeleteArrows();
   
   
	if(ShowArrows)
	{
		if(DotsforArrow ==4)
		{
			for (i=Bars; i>=0;i--)
			{
				if (AlertOnBarClose) t0 = i + 1;
				else t0 = i;
				
				if((buf1_dn[t0+1]==EMPTY_VALUE || buf2_dn[t0+1]==EMPTY_VALUE || buf3_dn[t0+1] ==EMPTY_VALUE || buf4_dn[t0+1]==EMPTY_VALUE) && (buf1_dn[t0]==1 && buf2_dn[t0]==1 + Gap * 1 && buf3_dn[t0] ==1 + Gap * 2 && buf4_dn[t0]==1 + Gap * 3))
				{
					ArrowGap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
					ObjectCreate("Down Arrow"+Time[t0],OBJ_ARROW,0, Time[t0],High[t0]+ArrowGap*Point);
					ObjectSet("Down Arrow"+Time[t0],OBJPROP_ARROWCODE,234);
					ObjectSet("Down Arrow"+Time[t0],OBJPROP_COLOR,DownArrowColor);
					Signal=-1;
					DoAlerts(i,Signal);
				}
               
				else
				if ((buf1_up[t0+1]==EMPTY_VALUE || buf2_up[t0+1]==EMPTY_VALUE || buf3_up[t0+1] ==EMPTY_VALUE || buf4_up[t0+1]==EMPTY_VALUE) && (buf1_up[t0]==1 && buf2_up[t0]==1 + Gap * 1 && buf3_up[t0] ==1 + Gap * 2 && buf4_up[t0]==1 + Gap * 3))
				{
					ArrowGap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
					ObjectCreate("Up Arrow"+Time[t0],OBJ_ARROW,0, Time[t0],Low[t0]-ArrowGap*Point);
					ObjectSet("Up Arrow"+Time[t0],OBJPROP_ARROWCODE,233);
					ObjectSet("Up Arrow"+Time[t0],OBJPROP_COLOR,UpArrowColor);
					Signal=1;
					DoAlerts(i,Signal);
				}
			}      
		}
		else if(DotsforArrow ==3)
		{
			for (i=Bars; i>=0;i--)
			{
				if (AlertOnBarClose) t0 = i + 1;
				else t0 = i;
            
				if((buf1_dn[t0+1]==EMPTY_VALUE || buf2_dn[t0+1]==EMPTY_VALUE || buf3_dn[t0+1] ==EMPTY_VALUE ) && (buf1_dn[t0]==1 && buf2_dn[t0]==1 + Gap * 1 && buf3_dn[t0] ==1 + Gap * 2))
				{
					ArrowGap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
					ObjectCreate("Down Arrow"+Time[t0],OBJ_ARROW,0, Time[t0],High[t0]+ArrowGap*2*Point);
					ObjectSet("Down Arrow"+Time[t0],OBJPROP_ARROWCODE,234);
					ObjectSet("Down Arrow"+Time[t0],OBJPROP_COLOR,DownArrowColor);
					Signal=-1;
					DoAlerts(i,Signal);
				}
               
				else
				if ((buf1_up[t0+1]==EMPTY_VALUE || buf2_up[t0+1]==EMPTY_VALUE || buf3_up[t0+1] ==EMPTY_VALUE) && (buf1_up[t0]==1 && buf2_up[t0]==1 + Gap * 1 && buf3_up[t0] ==1 + Gap * 2))
				{
					ArrowGap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
					ObjectCreate("Up Arrow"+Time[t0],OBJ_ARROW,0, Time[t0],Low[t0]-ArrowGap*Point);
					ObjectSet("Up Arrow"+Time[t0],OBJPROP_ARROWCODE,233);
					ObjectSet("Up Arrow"+Time[t0],OBJPROP_COLOR,UpArrowColor);
					Signal=1;
					DoAlerts(i,Signal);
				}
			}      
		}
      
		else if(DotsforArrow ==2)
		{
			for (i=Bars; i>=0;i--)
			{
				if (AlertOnBarClose) t0 = i + 1;
                else t0 = i;
            
				if((buf1_dn[t0+1]==EMPTY_VALUE || buf2_dn[t0+1]==EMPTY_VALUE) && (buf1_dn[t0]==1 && buf2_dn[t0]==1 + Gap * 1))
				{
					ArrowGap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
					ObjectCreate("Down Arrow"+Time[t0],OBJ_ARROW,0, Time[t0],High[t0]+ArrowGap*2*Point);
					ObjectSet("Down Arrow"+Time[t0],OBJPROP_ARROWCODE,234);
					ObjectSet("Down Arrow"+Time[t0],OBJPROP_COLOR,DownArrowColor);
					Signal=-1;
					DoAlerts(i,Signal);
				}
               
				else
				if ((buf1_up[t0+1]==EMPTY_VALUE || buf2_up[t0+1]==EMPTY_VALUE) && (buf1_up[t0]==1 && buf2_up[t0]==1 + Gap * 1))
				{
					ArrowGap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
					ObjectCreate("Up Arrow"+Time[t0],OBJ_ARROW,0, Time[t0],Low[t0]-ArrowGap*Point);
					ObjectSet("Up Arrow"+Time[t0],OBJPROP_ARROWCODE,233);
					ObjectSet("Up Arrow"+Time[t0],OBJPROP_COLOR,UpArrowColor);
					Signal=1;
					DoAlerts(i,Signal);
				}
			}      
		}
	}
	return(0);
}
	else
	{
		Alert("MUST USE 3 or 4 for DotsforArrow variable");
	}
	return(0);

}
//+------------------------------------------------------------------+
void DoAlerts(int i, int signal)
{
	if (SendAlert && i == 0)
	{
		if (AlertDone == false)
		{
			if (signal > 0)
			{
				AlertDone = true;
				Alert(AlertMessageUp+" ",Symbol());
				PlaySound("Alert.wav");
				if (SendEmail)
				{SendMail(AlertMessageUp+" ",Symbol());}
			}
			else
			if (signal < 0)
			{
				AlertDone = true;
				Alert(AlertMessageDn+" ",Symbol());
				PlaySound("Alert.wav");
				if (SendEmail)
				{SendMail(AlertMessageDn+" ",Symbol());}
			}
			else
			{AlertDone = false;}
		}
	}
}


void DeleteArrows()
{
	for(int i = Bars;i>=0;i--)
	{
		ObjectDelete("Down Arrow"+ Time[i]);
		ObjectDelete("Up Arrow"+ Time[i]);
	}
}