//+------------------------------------------------------------------+
//|                                          BullBearHelper 1.01.mq4 |
//|                                            modified by gspe 2010 |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, AKA TradeForexFX"
#property link      "http://www./"

//---- indicator settings
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color3 LimeGreen
#property indicator_width3 4
#property indicator_color4 Red
#property indicator_width4 4
//#property indicator_minimum 0.5
//#property indicator_maximum 2.0

//---- indicator parameters
extern int BullsBearsPeriod = 13;

//---- indicator buffers
double ExtBull[];
double ExtBear[];
double BullUp[];
double BearDn[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	string short_name;
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

//---- drawing settings
	SetIndexStyle(0, DRAW_NONE);
	SetIndexStyle(1, DRAW_NONE);
	SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID);
	SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID);
//---- indicator buffers mapping
	SetIndexBuffer(0, ExtBull);
	SetIndexBuffer(1, ExtBear);
	SetIndexBuffer(2, BullUp);
	SetIndexBuffer(3, BearDn);
//---- name for DataWindow and indicator subwindow label
	short_name="BullBearHelper 1.00 (" + BullsBearsPeriod + ")";
	IndicatorShortName(short_name);
	SetIndexLabel(0,"Bull");
	SetIndexLabel(1,"Bear");
	SetIndexLabel(2,NULL);
	SetIndexLabel(3,NULL);
//---- indicator level settings
	SetLevelValue(0, 0.0);

//----
	return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//---- 

//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	int limit, i, counter;
	double Bullp, Bearp;
	int counted_bars=IndicatorCounted();
//---- check for possible errors
	if(counted_bars<0) return(-1);
	
//---- last counted bar will be recounted
	if(counted_bars>0) counted_bars--;

	limit=Bars-counted_bars;
   
	for(i = limit-1; i >= 0; i--)
	{
		Bullp = (iBullsPower(NULL, 0, BullsBearsPeriod,PRICE_CLOSE,i));
		Bearp = (iBearsPower(NULL, 0, BullsBearsPeriod,PRICE_CLOSE,i));
		
		ExtBull[i] = Bullp;
		ExtBear[i] = Bearp;

		if ( MathAbs(Bullp) > MathAbs(Bearp))
		{
			BullUp[i] = Bullp;
			BearDn[i] = EMPTY_VALUE;
		}
		else if ( MathAbs(Bullp) < MathAbs(Bearp))
		{
			BearDn[i] = Bearp;
			BullUp[i] = EMPTY_VALUE;
		}
	}
	return(0);
}

